diff --git a/MAINTAINERS b/MAINTAINERS
index cd9bf60..697cc1b 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -164,7 +164,7 @@ ARM UNIPHIER
 M:	Masahiro Yamada <yamada.m@jp.panasonic.com>
 S:	Maintained
 T:	git git://git.denx.de/u-boot-uniphier.git
-F:	arch/arm/cpu/armv7/uniphier/
+F:	arch/arm/mach-uniphier/
 F:	arch/arm/include/asm/arch-uniphier/
 F:	configs/ph1_*_defconfig
 F:	drivers/serial/serial_uniphier.c
diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index f801cbf..23c5bab 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -712,7 +712,7 @@ source "arch/arm/cpu/armv7/s5pc1xx/Kconfig"
 
 source "arch/arm/mach-tegra/Kconfig"
 
-source "arch/arm/cpu/armv7/uniphier/Kconfig"
+source "arch/arm/mach-uniphier/Kconfig"
 
 source "arch/arm/cpu/arm926ejs/versatile/Kconfig"
 
diff --git a/arch/arm/Makefile b/arch/arm/Makefile
index f1ae929..1b1d222 100644
--- a/arch/arm/Makefile
+++ b/arch/arm/Makefile
@@ -7,6 +7,7 @@
 machine-$(CONFIG_ARCH_AT91)		+= at91
 # TODO: rename CONFIG_TEGRA -> CONFIG_ARCH_TEGRA
 machine-$(CONFIG_TEGRA)			+= tegra
+machine-$(CONFIG_ARCH_UNIPHIER)		+= uniphier
 
 machdirs := $(patsubst %,arch/arm/mach-%/,$(machine-y))
 
diff --git a/arch/arm/cpu/armv7/Makefile b/arch/arm/cpu/armv7/Makefile
index 91e6923..254ca3d 100644
--- a/arch/arm/cpu/armv7/Makefile
+++ b/arch/arm/cpu/armv7/Makefile
@@ -57,6 +57,5 @@ obj-$(CONFIG_SOCFPGA) += socfpga/
 obj-$(if $(filter stv0991,$(SOC)),y) += stv0991/
 obj-$(CONFIG_ARCH_SUNXI) += sunxi/
 obj-$(CONFIG_U8500) += u8500/
-obj-$(CONFIG_ARCH_UNIPHIER) += uniphier/
 obj-$(CONFIG_VF610) += vf610/
 obj-$(CONFIG_ZYNQ) += zynq/
diff --git a/arch/arm/cpu/armv7/uniphier/Kconfig b/arch/arm/mach-uniphier/Kconfig
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/Kconfig
rename to arch/arm/mach-uniphier/Kconfig
diff --git a/arch/arm/cpu/armv7/uniphier/Makefile b/arch/arm/mach-uniphier/Makefile
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/Makefile
rename to arch/arm/mach-uniphier/Makefile
diff --git a/arch/arm/cpu/armv7/uniphier/board_common.c b/arch/arm/mach-uniphier/board_common.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/board_common.c
rename to arch/arm/mach-uniphier/board_common.c
diff --git a/arch/arm/cpu/armv7/uniphier/board_early_init_r.c b/arch/arm/mach-uniphier/board_early_init_r.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/board_early_init_r.c
rename to arch/arm/mach-uniphier/board_early_init_r.c
diff --git a/arch/arm/cpu/armv7/uniphier/board_late_init.c b/arch/arm/mach-uniphier/board_late_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/board_late_init.c
rename to arch/arm/mach-uniphier/board_late_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/board_postclk_init.c b/arch/arm/mach-uniphier/board_postclk_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/board_postclk_init.c
rename to arch/arm/mach-uniphier/board_postclk_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/cache_uniphier.c b/arch/arm/mach-uniphier/cache_uniphier.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/cache_uniphier.c
rename to arch/arm/mach-uniphier/cache_uniphier.c
diff --git a/arch/arm/cpu/armv7/uniphier/cmd_ddrphy.c b/arch/arm/mach-uniphier/cmd_ddrphy.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/cmd_ddrphy.c
rename to arch/arm/mach-uniphier/cmd_ddrphy.c
diff --git a/arch/arm/cpu/armv7/uniphier/cmd_pinmon.c b/arch/arm/mach-uniphier/cmd_pinmon.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/cmd_pinmon.c
rename to arch/arm/mach-uniphier/cmd_pinmon.c
diff --git a/arch/arm/cpu/armv7/uniphier/cpu_info.c b/arch/arm/mach-uniphier/cpu_info.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/cpu_info.c
rename to arch/arm/mach-uniphier/cpu_info.c
diff --git a/arch/arm/cpu/armv7/uniphier/ddrphy_training.c b/arch/arm/mach-uniphier/ddrphy_training.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ddrphy_training.c
rename to arch/arm/mach-uniphier/ddrphy_training.c
diff --git a/arch/arm/cpu/armv7/uniphier/dram_init.c b/arch/arm/mach-uniphier/dram_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/dram_init.c
rename to arch/arm/mach-uniphier/dram_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/init_page_table.S b/arch/arm/mach-uniphier/init_page_table.S
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/init_page_table.S
rename to arch/arm/mach-uniphier/init_page_table.S
diff --git a/arch/arm/cpu/armv7/uniphier/lowlevel_init.S b/arch/arm/mach-uniphier/lowlevel_init.S
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/lowlevel_init.S
rename to arch/arm/mach-uniphier/lowlevel_init.S
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/Makefile b/arch/arm/mach-uniphier/ph1-ld4/Makefile
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/Makefile
rename to arch/arm/mach-uniphier/ph1-ld4/Makefile
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/bcu_init.c b/arch/arm/mach-uniphier/ph1-ld4/bcu_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/bcu_init.c
rename to arch/arm/mach-uniphier/ph1-ld4/bcu_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/board_info.c b/arch/arm/mach-uniphier/ph1-ld4/board_info.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/board_info.c
rename to arch/arm/mach-uniphier/ph1-ld4/board_info.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/boot-mode.c b/arch/arm/mach-uniphier/ph1-ld4/boot-mode.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/boot-mode.c
rename to arch/arm/mach-uniphier/ph1-ld4/boot-mode.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/clkrst_init.c b/arch/arm/mach-uniphier/ph1-ld4/clkrst_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/clkrst_init.c
rename to arch/arm/mach-uniphier/ph1-ld4/clkrst_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/ddrphy_init.c b/arch/arm/mach-uniphier/ph1-ld4/ddrphy_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/ddrphy_init.c
rename to arch/arm/mach-uniphier/ph1-ld4/ddrphy_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/lowlevel_debug.S b/arch/arm/mach-uniphier/ph1-ld4/lowlevel_debug.S
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/lowlevel_debug.S
rename to arch/arm/mach-uniphier/ph1-ld4/lowlevel_debug.S
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/pinctrl.c b/arch/arm/mach-uniphier/ph1-ld4/pinctrl.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/pinctrl.c
rename to arch/arm/mach-uniphier/ph1-ld4/pinctrl.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/platdevice.c b/arch/arm/mach-uniphier/ph1-ld4/platdevice.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/platdevice.c
rename to arch/arm/mach-uniphier/ph1-ld4/platdevice.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/pll_init.c b/arch/arm/mach-uniphier/ph1-ld4/pll_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/pll_init.c
rename to arch/arm/mach-uniphier/ph1-ld4/pll_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/pll_spectrum.c b/arch/arm/mach-uniphier/ph1-ld4/pll_spectrum.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/pll_spectrum.c
rename to arch/arm/mach-uniphier/ph1-ld4/pll_spectrum.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/sbc_init.c b/arch/arm/mach-uniphier/ph1-ld4/sbc_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/sbc_init.c
rename to arch/arm/mach-uniphier/ph1-ld4/sbc_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/sg_init.c b/arch/arm/mach-uniphier/ph1-ld4/sg_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/sg_init.c
rename to arch/arm/mach-uniphier/ph1-ld4/sg_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-ld4/umc_init.c b/arch/arm/mach-uniphier/ph1-ld4/umc_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-ld4/umc_init.c
rename to arch/arm/mach-uniphier/ph1-ld4/umc_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/Makefile b/arch/arm/mach-uniphier/ph1-pro4/Makefile
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/Makefile
rename to arch/arm/mach-uniphier/ph1-pro4/Makefile
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/board_info.c b/arch/arm/mach-uniphier/ph1-pro4/board_info.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/board_info.c
rename to arch/arm/mach-uniphier/ph1-pro4/board_info.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/boot-mode.c b/arch/arm/mach-uniphier/ph1-pro4/boot-mode.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/boot-mode.c
rename to arch/arm/mach-uniphier/ph1-pro4/boot-mode.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/clkrst_init.c b/arch/arm/mach-uniphier/ph1-pro4/clkrst_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/clkrst_init.c
rename to arch/arm/mach-uniphier/ph1-pro4/clkrst_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/ddrphy_init.c b/arch/arm/mach-uniphier/ph1-pro4/ddrphy_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/ddrphy_init.c
rename to arch/arm/mach-uniphier/ph1-pro4/ddrphy_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/lowlevel_debug.S b/arch/arm/mach-uniphier/ph1-pro4/lowlevel_debug.S
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/lowlevel_debug.S
rename to arch/arm/mach-uniphier/ph1-pro4/lowlevel_debug.S
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/pinctrl.c b/arch/arm/mach-uniphier/ph1-pro4/pinctrl.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/pinctrl.c
rename to arch/arm/mach-uniphier/ph1-pro4/pinctrl.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/platdevice.c b/arch/arm/mach-uniphier/ph1-pro4/platdevice.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/platdevice.c
rename to arch/arm/mach-uniphier/ph1-pro4/platdevice.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/pll_init.c b/arch/arm/mach-uniphier/ph1-pro4/pll_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/pll_init.c
rename to arch/arm/mach-uniphier/ph1-pro4/pll_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/pll_spectrum.c b/arch/arm/mach-uniphier/ph1-pro4/pll_spectrum.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/pll_spectrum.c
rename to arch/arm/mach-uniphier/ph1-pro4/pll_spectrum.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/sbc_init.c b/arch/arm/mach-uniphier/ph1-pro4/sbc_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/sbc_init.c
rename to arch/arm/mach-uniphier/ph1-pro4/sbc_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/sg_init.c b/arch/arm/mach-uniphier/ph1-pro4/sg_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/sg_init.c
rename to arch/arm/mach-uniphier/ph1-pro4/sg_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-pro4/umc_init.c b/arch/arm/mach-uniphier/ph1-pro4/umc_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-pro4/umc_init.c
rename to arch/arm/mach-uniphier/ph1-pro4/umc_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/Makefile b/arch/arm/mach-uniphier/ph1-sld8/Makefile
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/Makefile
rename to arch/arm/mach-uniphier/ph1-sld8/Makefile
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/bcu_init.c b/arch/arm/mach-uniphier/ph1-sld8/bcu_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/bcu_init.c
rename to arch/arm/mach-uniphier/ph1-sld8/bcu_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/board_info.c b/arch/arm/mach-uniphier/ph1-sld8/board_info.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/board_info.c
rename to arch/arm/mach-uniphier/ph1-sld8/board_info.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/boot-mode.c b/arch/arm/mach-uniphier/ph1-sld8/boot-mode.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/boot-mode.c
rename to arch/arm/mach-uniphier/ph1-sld8/boot-mode.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/clkrst_init.c b/arch/arm/mach-uniphier/ph1-sld8/clkrst_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/clkrst_init.c
rename to arch/arm/mach-uniphier/ph1-sld8/clkrst_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/ddrphy_init.c b/arch/arm/mach-uniphier/ph1-sld8/ddrphy_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/ddrphy_init.c
rename to arch/arm/mach-uniphier/ph1-sld8/ddrphy_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/lowlevel_debug.S b/arch/arm/mach-uniphier/ph1-sld8/lowlevel_debug.S
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/lowlevel_debug.S
rename to arch/arm/mach-uniphier/ph1-sld8/lowlevel_debug.S
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/pinctrl.c b/arch/arm/mach-uniphier/ph1-sld8/pinctrl.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/pinctrl.c
rename to arch/arm/mach-uniphier/ph1-sld8/pinctrl.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/platdevice.c b/arch/arm/mach-uniphier/ph1-sld8/platdevice.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/platdevice.c
rename to arch/arm/mach-uniphier/ph1-sld8/platdevice.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/pll_init.c b/arch/arm/mach-uniphier/ph1-sld8/pll_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/pll_init.c
rename to arch/arm/mach-uniphier/ph1-sld8/pll_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/pll_spectrum.c b/arch/arm/mach-uniphier/ph1-sld8/pll_spectrum.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/pll_spectrum.c
rename to arch/arm/mach-uniphier/ph1-sld8/pll_spectrum.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/sbc_init.c b/arch/arm/mach-uniphier/ph1-sld8/sbc_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/sbc_init.c
rename to arch/arm/mach-uniphier/ph1-sld8/sbc_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/sg_init.c b/arch/arm/mach-uniphier/ph1-sld8/sg_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/sg_init.c
rename to arch/arm/mach-uniphier/ph1-sld8/sg_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/ph1-sld8/umc_init.c b/arch/arm/mach-uniphier/ph1-sld8/umc_init.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/ph1-sld8/umc_init.c
rename to arch/arm/mach-uniphier/ph1-sld8/umc_init.c
diff --git a/arch/arm/cpu/armv7/uniphier/reset.c b/arch/arm/mach-uniphier/reset.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/reset.c
rename to arch/arm/mach-uniphier/reset.c
diff --git a/arch/arm/cpu/armv7/uniphier/smp.S b/arch/arm/mach-uniphier/smp.S
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/smp.S
rename to arch/arm/mach-uniphier/smp.S
diff --git a/arch/arm/cpu/armv7/uniphier/spl.c b/arch/arm/mach-uniphier/spl.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/spl.c
rename to arch/arm/mach-uniphier/spl.c
diff --git a/arch/arm/cpu/armv7/uniphier/support_card.c b/arch/arm/mach-uniphier/support_card.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/support_card.c
rename to arch/arm/mach-uniphier/support_card.c
diff --git a/arch/arm/cpu/armv7/uniphier/timer.c b/arch/arm/mach-uniphier/timer.c
similarity index 100%
rename from arch/arm/cpu/armv7/uniphier/timer.c
rename to arch/arm/mach-uniphier/timer.c